<?php
/**
 * Mirasvit
 *
 * This source file is subject to the Mirasvit Software License, which is available at https://mirasvit.com/license/.
 * Do not edit or add to this file if you wish to upgrade the to newer versions in the future.
 * If you wish to customize this module for your needs.
 * Please refer to http://www.magentocommerce.com for more information.
 *
 * @category  Mirasvit
 * @package   mirasvit/module-sales-rule
 * @version   1.0.4
 * @copyright Copyright (C) 2019 Mirasvit (https://mirasvit.com/)
 */



namespace Mirasvit\PromoBanner\Api\Repository;

use Mirasvit\PromoBanner\Api\Data\BannerInterface;

interface BannerRepositoryInterface
{
    /**
     * @return BannerInterface[]|\Mirasvit\PromoBanner\Model\ResourceModel\Banner\Collection
     */
    public function getCollection();

    /**
     * @return BannerInterface
     */
    public function create();

    /**
     * @param int $id
     *
     * @return BannerInterface|false
     */
    public function get($id);

    /**
     * @param BannerInterface $banner
     *
     * @return BannerInterface
     */
    public function save(BannerInterface $banner);

    /**
     * @param BannerInterface $banner
     *
     * @return $this
     */
    public function delete(BannerInterface $banner);
}